using System;


#region Henkilon tiedot voitaisiin tallentaa esimerkiksi näin (tämän luennon ulkopuolista asiaa)

public class Henkilo
{
    public string Nimi { get; set; }
    public int Syntymavuosi { get; set; }
    public string Osoite { get; set; }
    public string Puhelin { get; set; }
    public string Email { get; set; }
    public string[] Harrastukset { get; set; }
    public double TilinSaldo { get; set; }

    // Henkilöllä on myös metodeja, kuten TulostaTiedot(), LaskeIka(), jne.
    // Opimme luokista lisää seuraavalla viikolla
}

#endregion

/// <summary>
/// Luento 10. Taulukot
/// </summary>
public class Taulukot
{
    /// <summary>
    /// Vielä taulukoista
    /// </summary>
    public static void Main()
    {
        // Muistutus/tarkennus: Taulukoiden arvojen tulisi liittyä toisiinsa ja
        // olla "samaa kategoriaa" (esim. lämpötilat, luennolle osallistujien nimet,
        // lumiukon pallot, ...)
        double[] lampotilat = { -1.0, 1.0, 2.0, -15.5, -14.5, -20.0, -30.0 };

        // double[] henkilonTiedot = { 42.1, 183.0, 75.0, -10.0 };
        // Tällä tavalla tietojen tallentaminen ei ole suositeltavaa.
        // Tähän tarkoitukseen paremmin sopivat luokat, tietueet tai monikot

        // Esimerkki 1: Taulukon alkioilla on kiinteä tyyppi, kuten muillakin muuttujilla
        // string[] henkilot = { "Antti-Jussi", "Jonne", "Tuomo", 4 };
        // int[] luvut = { 3, 2, 1, "Jono" };
        // var luvut = new int[] { 3, 2, 1, "Jono"};

        // Esimerkki 2: Taulukon sisältöä voi kuitenkin muuttaa.
        int[] luvut = { 1, 2, 3, 5, 2, -1, 2 };
        luvut[0] = 5;
        Console.WriteLine(luvut[0]);

        // Esimerkki 3: Alkioiden vaihto (ns. swap)
        luvut[0] = 2;
        luvut[6] = 1;
        Console.WriteLine($"Ekassa on nyt {luvut[0]} ja vikassa {luvut[6]}");
        // Mikä on taulukon viimeisessä paikassa oleva alkio?
        int temp = luvut[luvut.Length - 1];
        // Kopioidaan ekasta paikasta luku viimeiseen
        luvut[luvut.Length - 1] = luvut[0];
        // Uudessa C#:ssa onnistuu myös näin:
        // luvut[^1] = luvut[0];

        luvut[0] = temp;
        Console.WriteLine($"Ekassa on nyt {luvut[0]} ja vikassa {luvut[6]}");

        // Esimerkki 4: TulostaJos(luvut, 1)
        TulostaJos(luvut, 1);

        // Esimerkki 5: MontakoLukuaEnnenNollaa(luvut)
        int[] luvut2 = { 1, 2, 3, 5, 2, -1, 2, 0, 8, 9, 1, -1, 0, 8, 9 };
        int ennenNollaa = MontakoLukuaEnnenNollaa(luvut2);

        // Esimerkki 6: Negatiivisten summa
        double[] luvut3 = { -1.5, -2.0, 0, 2, 5, -3 };
        double summa = NegatiivistenSumma(luvut3);
        Console.WriteLine($"Negatiivisten lukujen summa on {summa}");

        // Esimerkki 7: Niiden merkkijonojen määrä, joista löytyy kirjain 'a'
        string[] nimet = { "Antti-Jussi", "Jonne", "Vesa", "Tuomo", "Antti Aarnio" };
        int nimetJoissaA = KuinkaMonessaEsiintyy(nimet, 'a');
    }

    /// <summary>
    /// Kuinka monessa merkkijonossa esiintyy etsittävä kirjain
    /// </summary>
    /// <param name="jonot">Merkkijonot</param>
    /// <param name="etsittavaMerkki">Etsittävä merkki</param>
    /// <returns>Jonojen lukumäärä</returns>
    /// <example>
    /// <pre name="test">
    /// string[] nimet = { "Antti-Jussi", "Jonne", "Vesa", "Tuomo", "Antti Aarnio" };
    /// KuinkaMonessaEsiintyy(nimet, 'a') === 3;
    /// KuinkaMonessaEsiintyy(nimet, 'b') === 0;
    /// KuinkaMonessaEsiintyy(nimet, 'A') === 3;
    /// KuinkaMonessaEsiintyy(new string[]{ }, 'a') === 0;
    /// </pre>
    /// </example>
    public static int KuinkaMonessaEsiintyy(string[] jonot, char etsittavaMerkki)
    {
        int monessako = 0;
        foreach (string jono in jonot)
        {
            if (jono.ToLower().IndexOf(char.ToLower(etsittavaMerkki)) >= 0)
            {
                monessako++;
            }
        }

        return monessako;
    }

    /// <summary>
    /// Negatiivisten lukujen summa
    /// </summary>
    /// <param name="luvut">Luvut</param>
    /// <returns>Summa</returns>
    public static double NegatiivistenSumma(double[] luvut)
    {
        double summa = 0.0;
        for (int i = 0; i < luvut.Length; i++)
        {
            // Tutkitaan onko alkion arvo negatiivinen
            if (luvut[i] < 0)
            {
                summa += luvut[i];
            }
        }

        return summa;
    }

    /// <summary>
    /// Montako lukua on ennen nollaa.
    /// </summary>
    /// <param name="luvut">Luvut</param>
    /// <returns>Montako ennen nollaa</returns>
    /// <example>
    /// <pre name="test">
    /// int[] luvut = { 1, 2, 3, 5, 2, -1, 2, 0, 8, 9, 1, -1, 0, 8, 9 };
    /// MontakoLukuaEnnenNollaa(luvut) === 7;
    /// MontakoLukuaEnnenNollaa(new int[] { }) === 0;
    /// MontakoLukuaEnnenNollaa(new int[] { 3, 2, 1 }) === 3;
    /// MontakoLukuaEnnenNollaa(new int[] { 0, 3, 2, 1 }) === 0;
    /// </pre>
    /// </example>
    public static int MontakoLukuaEnnenNollaa(int[] luvut)
    {
        int montakoLukua = 0;
        foreach (int luku in luvut)
        {
            if (luku == 0) break;
            else montakoLukua++;
        }

        return montakoLukua;
    }

    /// <summary>
    /// Tulosta luku mikäli se mätsää etsittävään lukuun
    /// </summary>
    /// <param name="luvut">Luvut</param>
    /// <param name="etsittavaLuku">Etsittävä luku</param>
    public static void TulostaJos(int[] luvut, int etsittavaLuku)
    {
        // Käydään läpi jokainen alkio taulukosta "luvut"
        // Jos alkion arvo on täsmälleen "etsittavaLuku"-parametrin arvo
        // Tulostetaan se
        for (int i = 0; i < luvut.Length; i++)
        {
            if (luvut[i] == etsittavaLuku)
            {
                Console.WriteLine(luvut[i]);
            }
        }
    }

    /// <summary>
    /// Kuinka monesta merkkijonosta löytyy etsittävä kirjain
    /// </summary>
    /// <param name="jonot">Jonot</param>
    /// <param name="etsittavaMerkki">Etsittävä merkki</param>
    /// <returns>Sopivien merkkijonojen määrä</returns>
    /// <example>
    /// <pre name="test">
    /// string[] jonot = { "Antti-Jussi", "Jonne", "Vesa", "Tuomo" };
    /// LoytyykoKirjain(jonot, 'a') === 2;
    /// LoytyykoKirjain(jonot, 'A') === 2;
    /// LoytyykoKirjain(jonot, 'b') === 0;
    /// LoytyykoKirjain(jonot, '-') === 1;
    /// string[] jonot2 = { "Jonne", "Jonne" };
    /// LoytyykoKirjain(jonot, 'j') === 2;
    /// string[] jonot3 = {  };
    /// LoytyykoKirjain(jonot, 'C') === 0;
    /// </pre>
    /// </example>
    public static int LoytyykoKirjain(string[] jonot, char etsittavaMerkki)
    {
        return 0;
    }
}